# w Oό` Ver.1.24

path = File.dirname( File.expand_path( $0 ) ) + '/'
require path + 'jwplot.rb'
require path + 'frmheron.rb'

LineColor = 1
LineType = 1
DefaultFont = 2
OutputFile = 'jwc_temp.txt'

# CLASS: wϊOό`
class HeronsFormula < JwPlotFile
	LENGTH = "LENGTH"
	AREA = "AREA"
	SPARA = "S"
	TOTAL = "TOTAL"

  def initialize( path )
  	@path = path
  	@pwd = File.expand_path( Dir.pwd ) + '/'
    @formats = Hash.new
    @formats[ LENGTH ] = NumberFormat.new( 10, 2 )
    @formats[ AREA ] = NumberFormat.new( 15, 5 )
    @formats[ SPARA ] = NumberFormat.new( 13, 3 )
    @formats[ TOTAL ] = NumberFormat.new( 12, 2 )

    @font = JwFont.new
    @font.id = DefaultFont

    @options = VRLocalScreen.newform( nil, nil, HeronsDialog )
    @options.path = @path
    @options.show

    if @options.answer
      @reference = Reference.new( @options.reference )

      prec = @options.precision
      @formats[ LENGTH ].set( prec + 8, prec )
      @formats[ AREA   ].set( @options.area_precision + 10, @options.area_precision )
      @formats[ SPARA  ].set( prec + 10, prec + 1 )
      @formats[ TOTAL  ].set( @options.total_precision + 10, @options.total_precision )

      @formats[ LENGTH ].trancated = @options.trancate?
      @formats[ LENGTH ].round5 = @options.round5?
      @formats[ AREA   ].trancated = ( @options.trancate? or @options.round5? )
      @formats[ TOTAL  ].trancated = ( @options.trancate? or @options.round5? )

			@tolerance = 0.1 ** prec
			@ignore_attr = true
      read
      draw
    end
  end

  def draw
    out = open( @pwd + OutputFile, 'w' )
    begin
      print "vZł...\n"

      if @options.layer != "Z"
        out.printf "ly%s\n", @options.layer
      end
      saved_font = @font.id
  		if @options.fontSize != "0"
  			@font.id = @options.fontSize.to_i
  			@font.draw out
  		end

			# f[^ΏۂɎOp`
			if @options.calcTriangle	
	      lines = @lines   # d
	      lines.uniq!
	      if @options.lineColor != "0"
	        out.printf "lc%s\n", @options.lineColor
	      else
	        out.printf "lc%s\n", @lineColor
	      end
	
	      # Op`ʃ[`
	      smc = 0
	      line_count = lines.length - 1
	      sk = Array.new( lines.length, -1 )
	      triangles = Hash.new
	      peaks = Array.new
	      triangle_groups = Array.new
	      for i in  0 .. line_count
	        if sk[ i ] < 0
	          sk[ i ] = smc
	          checkLine( lines, i, sk, smc )
	          for k in 0 .. line_count
	            if sk[ k ] == smc
	              searchTriangle( lines, smc, k, triangles, sk, peaks )
	            end
	          end
	          if triangles.length > 0
		          triangle_groups.push triangles.values
		          triangles = Hash.new
		        end
	          smc += 1
	        end
	      end
				sk.clear

			# \bh}`ΏۂɎOp`
			else
	      peaks = Array.new
	      lines = Array.new
	      triangle_groups = Hash.new

				for solid in @solids
					color = solid.pen + "-" + solid.color.to_s
					if ! triangle_groups.has_key? color
						triangle_groups[ color ] = Array.new
					end
					if solid.peaks.length == 3
						triangle_groups[ color ] << Triangle.new( solid.peaks[0], solid.peaks[1], solid.peaks[2] )
						lines << Line.new( solid.peaks[0], solid.peaks[1] )
						lines << Line.new( solid.peaks[1], solid.peaks[2] )
						lines << Line.new( solid.peaks[2], solid.peaks[0] )
					elsif solid.peaks.length == 4
						triangle_groups[ color ] << Triangle.new( solid.peaks[0], solid.peaks[1], solid.peaks[2] )
						triangle_groups[ color ] << Triangle.new( solid.peaks[2], solid.peaks[3], solid.peaks[0] )
						lines << Line.new( solid.peaks[0], solid.peaks[1] )
						lines << Line.new( solid.peaks[1], solid.peaks[2] )
						lines << Line.new( solid.peaks[2], solid.peaks[3] )
						lines << Line.new( solid.peaks[3], solid.peaks[0] )
						lines << Line.new( solid.peaks[2], solid.peaks[0] )
					end
					for peak in solid.peaks
						peaks << peak
					end
				end

				triangle_groups = triangle_groups.values
				peaks.uniq!
				lines.uniq!
			end

			# n̕
			for triangles in triangle_groups
				triangles.extend TriangleArray
				triangles.sortHorizontal = @options.sortHorizontal
				triangles.sortAscent = @options.sortAscent
			end
			triangle_groups.sort!
			if triangle_groups.length == 1
				triangle_groups[0].center		# for annotate sort orientation
			end
			for triangles in triangle_groups
				triangles.sort!
			end

      # _ɓ_͉~
      if @options.drawPoint?
        peaks.uniq!
        radius = @options.radius * scale.value
        if @options.pointLayer != "Z"
    			out.printf "ly%s\n", @options.pointLayer
    		else
    			out.printf "ly%s\n", @layer
    		end
        if ! @options.drawCircle?
					if @options.pointType != "0"
      			out.printf "pn%s\n", @options.pointType
      		end
        else
					if @options.circleColor != "0"
      			out.printf "lc%s\n", @options.circleColor
      		end
        end
  
        for peak in peaks
          if @options.drawCircle?
            out.printf "ci %e %e %e\n", peak.x, peak.y, radius
          else
            peak.draw( out )
          end
        end
      end
      peaks.clear		# ΍

      # QƔԍL
			lengthFont = @font.clone
			if @options.lengthFont != "0"
				lengthFont.id = @options.lengthFont.to_i
			else
				lengthFont.id = saved_font
			end

			@font.scale = @scale
      area_format = @formats[ AREA ].clone
      area_format.suffix = "m^u2"
      area_format.prefix = '^$' + @options.areaColor		if @options.areaColor != "0"
			for group in triangle_groups
	      for triangle in group
	        out.printf "#sankaku = %s\n", triangle.key

	        triangle.name = @reference.to_s.clone   # QƔԍL
	        triangle.markType = @options.refMark
	        triangle.markAspect = @options.markAspect
	        triangle.markScale = @options.markScale
	        if @options.markColor == "0"
	        	triangle.markColor = @lineColor
	        else
	        	triangle.markColor = @options.markColor
	        end
					triangle.refColor = @options.fontColor

	        if @options.drawArea?
	          triangle.drawArea( area_format, @formats[ LENGTH ], @font, out )
	        else
	          triangle.drawName( @font, out )
	        end
	        @reference.succ!
	      end

	      @reference.succ_root!											# U~n̏ꍇAeԂi߂
			end

      # ӂĕ`Eӂ̐@L
      if @options.drawLine? or @options.drawLength?
	      plus = @options.lengthMargin * scale.value
        pathColor = checkDefaultColor( @options.lineColor ).to_i
        pathLayer = checkDefaultLayer( @options.pathLayer )
        heightLayer = checkDefaultLayer( @options.heightLayer )
        lengthLayer = checkDefaultLayer( @options.lengthLayer )

				lengthFont = @font.clone
				if @options.lengthFont != "0"
					lengthFont.id = @options.lengthFont.to_i
				else
					lengthFont.id = saved_font
				end
				lengthFont.draw out

				pathes = Array.new
				for group in triangle_groups
	      	for triangle in group
	      		checkDuplication pathes, triangle.l1, pathColor
	      		checkDuplication pathes, triangle.l2, pathColor
	      		checkDuplication pathes, triangle.l3, pathColor
	      	end
	      end

				len_format = @formats[LENGTH].clone
				len_format.prefix = '^$' + @options.lengthFontColor		if @options.lengthFontColor != "0"
				if @options.viaHeron
					for line in pathes
						if @options.drawLine?
		          out.printf "ly%s\n", pathLayer
							line.draw( out )
						end
						if @options.drawLength?
		          out.printf "ly%s\n", lengthLayer
							line.writeSize( plus, lengthFont, len_format, out )
						end
					end
				else
					height_pen = JwPen.new
					height_pen.color = checkDefaultColor( @options.heightColor ).to_i
					height_pen.type = checkDefaultStyle(@options.heightStyle ).to_i
					for group in triangle_groups
	      		for triangle in group
	      			heightPath = triangle.heightPath
							if @options.drawLength?
								out.printf "ly%s\n", lengthLayer
								heightPath.writeSize( plus, lengthFont, len_format, out )
								triangle.bottomPath.writeSize( plus, lengthFont, len_format, out )
							end
							out.printf "ly%s\n", heightLayer
							height_pen.draw( out )
							heightPath.draw( out )
						end
					end

					if @options.drawLine?
						out.printf "ly%s\n", pathLayer
						for line in pathes
							line.draw( out )
						end
					end
				end
      end
  
      # vZ\L

			@pen.draw( out )
      is_table_loaded = false
      if @options.drawTable?
        print "vZ\oĂ܂...\n"
        require @path + 'table.rb'
        is_table_loaded = true

				if @options.tableLayer == "Z"
					out.printf "ly%s\n", @layer
				else
					out.printf "ly%s\n", @options.tableLayer
				end
 				if @options.tableFont == "0"
					@font.id = saved_font
				else
					@font.id = @options.tableFont.to_i
				end
				@font.draw out

				table = HeronsTable.new
        table.path = @path
        table.configFile = @options.tableConfig
        table.subtotal = @options.subtotal
        table.viaHeron = @options.viaHeron
        table.readConfig
        table.draw( triangle_groups, @positions[ 1 ], @font, @formats, out )
      end
  
      # vZ\Excelɏo
      if @options.drawExcel?
        print "Excelt@CoĂ܂...\n"
        if not is_table_loaded
          require @path + 'table.rb'
        end

        table = HeronsExcel.new
        table.path = @path
        table.configFile = @options.tableConfig
        table.excelFile = @options.excelFile
        table.scale = @options.excelScale
        table.subtotal = @options.subtotal
        table.viaHeron = @options.viaHeron
        table.readConfig
        table.draw( triangle_groups, @font, @formats )
      end

			if pathes != nil and @options.calcTriangle
	      if pathes.length < lines.length
	        out.printf "h#Op`ȊO̐(%d){܂\n", lines.length - written.length
	      end
	    end

    ensure
      out.close
      print "\nI܂B\nDOSvvgĂB\n"
    end
  end

    # A smc Ń}[N
    def checkLine( lines, i, sk, smc )
      line_count = lines.length - 1
			connected = Array.new

      begin
        if connected.length == 0
          base = lines[ i ]
        else
          base = connected.pop
				end

        for k in 0 .. line_count
          if sk[ k ] < 0
            target = lines[ k ]
            if target.touched?(base, @tolerance)
              sk[ k ] = smc
              connected.push target;
            end
          end
        end
      end until connected.length == 0

			connected = nil
    end

    #OpF
    def searchTriangle( lines, smc, i, triangles, sk, peaks)
      line_count = lines.length - 1
      lineA = lines[ i ]

      for k in 0 .. line_count
        if (i != k) and sk[ i ] == smc

          lineB = lines[ k ]
          if lineB.touched?(lineA.from, @tolerance)
            peakA = lineA.to
            if lineB.from.touched?(lineA.from, @tolerance)
              peakB = lineB.to
            else
              peakB = lineB.from
            end

            for t in 0 .. line_count
              if (i!=t) and (t!=k) and (sk[ i ] == smc)
                lineC = lines[ t ]
                if peakB.touched?(lineC.from, @tolerance) and peakA.touched?(lineC.to, @tolerance) or peakB.touched?(lineC.to, @tolerance) and peakA.touched?(lineC.from, @tolerance)
                  id = Array[i, k, t].sort.join ","
                  if not triangles.key?( id )
                    triangles[ id ] = Triangle.new( lineA.from, peakA, peakB )
                    triangles[ id ].key = id
                    triangles[ id ].group = smc

                    peaks.push lineA.from   # e_̍Wlۑ
                    peaks.push peakA
                    peaks.push peakB
                  end
                end
              end
            end
          end
        end
      end
    end

	#dӂ_ɕύX
	def checkDuplication( pathes, line, color)
		found = false
		for path in pathes
			if path == line
				path.pen.color = checkDefaultColor( @options.insideColor ).to_i
				path.pen.type = checkDefaultStyle( @options.insideStyle ).to_i
				found = true
				break
			end
		end
		if not found
			pathes << JwLine.new( line.from, line.to )
			pathes.last.pen.color = color
		end
	end
end

# CLASS: Op`
class Triangle
  attr :p1, true
  attr :p2, true
  attr :p3, true
  attr :l1, true
  attr :l2, true
  attr :l3, true
  attr :name,						true
  attr :key,						true
  attr :group,					true
	attr :markType,				true
	attr :markScale,			true
	attr :markAspect,			true
	attr :markColor,			true
	attr :refColor,				true
	attr :sortHorizontal,	true
	attr :sortAscent,			true

  # CONSTRUCTOR
  def initialize( p1, p2, p3 )
    @p1 = p1
    @p2 = p2
    @p3 = p3

    @l1 = Line.new( p1, p2 )
    @l2 = Line.new( p2, p3 )
    @l3 = Line.new( p3, p1 )

    @name = ""
    @key = ""
    @markType = "ȉ~"
    @markScale = 1.0
    @markAspect = 0.7
    @markColor = "4"
    @refColor = "0"
    @sortHorizontal = true
    @sortAscent = true
  end

  # METHOD: w̌ɂ鋁
  def heronsArea( format )
    a = format.number!( @l1.length / 1000 )
    b = format.number!( @l2.length / 1000 )
    c = format.number!( @l3.length / 1000 )

    ss = (a + b + c) / 2
    s = ss * (ss - a) * (ss - b) * (ss - c)
    if s < 0.0
    	0.0
    else
    	Math.sqrt( ss * (ss - a) * (ss - b) * (ss - c) )
    end
  end

  def heronsParam( format )
    a = format.number!( @l1.length / 1000 )
    b = format.number!( @l2.length / 1000 )
    c = format.number!( @l3.length / 1000 )

    ss = (a + b + c) / 2
  end

  # METHOD: Op`̏dS_
  def center
  	if @center == nil
	    @center = Point.new( (@p1.x + @p2.x + @p3.x) / 3, (@p1.y + @p2.y + @p3.y) / 3 )
		end
    @center.sortHorizontal = @sortHorizontal
    @center.sortAscent = @sortAscent

    @center
  end

  # METHOD: Op` QNo.L
  def drawName( font, out )
    ctr = center()
		name = JwString.new( @name )
		name.font = font
		name.center = ctr
		name.text = '^$' + @refColor + @name		if @refColor != "0"
		name.draw out
		name_size = name.width

    x = ctr.x
    y = ctr.y

    if @markColor != "0"
    	out.printf "lc%s\n", @markColor     # ȉ~}[NL
    end
    if @name.length <= 3
    	name.text = "****"
    	radius = name.width * @markScale * 1.2
    else
    	radius = name_size * @markScale * 1.2
    end
    case @markType
    	when "ȉ~"
    		out.printf("ci %e %e %e %e %e %e %e\n",x,y,radius,0,0,@markAspect,0)
    	when "~"
    		out.printf("ci %e %e %e\n",x,y,radius)
    end
  end

  # METHOD: Op` QNo.@ƖʐϋL
  def drawArea( area_format, line_format, font, out )
    ctr = center()

		name = JwString.new
		name.text = @name
		name.font = font
		name.bottom_center = ctr
		name.text = '^$' + @refColor + @name		if @refColor != "0"
		name.draw out
		name_size = name.width

    area_format.number = heronsArea( line_format )
    area_str = area_format.to_s.strip
    name.text = area_str
		name.top_center = Point.new( ctr.x, ctr.y - 0.2 * font.scale.value )
		name.draw out
		area_size = name.width

		if @markColor != "0"
    	out.printf "lc%s\n", @markColor     # ȉ~}[NL
    end
    if name_size < area_size
      radius = area_size * @markScale * 1.2
    else
      if @name.length <= 3
      	name.text = "****"
        radius = name.width * @markScale * 1.2
      else
        radius = name_size * @markScale * 1.2
      end
    end
    case @markType
    	when "ȉ~"
    		out.printf("ci %e %e %e %e %e %e %e\n",ctr.x, ctr.y, radius, 0,0, @markAspect, 0)
    	when "~"
    		out.printf("ci %e %e %e\n",ctr.x, ctr.y, radius)
    end
    out.printf("%e %e %e %e\n", ctr.x - radius, ctr.y, ctr.x + radius, ctr.y)
  end

  # rZq <=> (\[gp)
  def <=>(other)
    return self.center <=> other.center
  end

	# ̐
	def heightPath
		@bp = bottomPath
		@hp = Line.new
		@hp.from = @top
		@hp.to = Point.new

		if @bp.to.x != @bp.from.x
			a = (@bp.to.y - @bp.from.y) / (@bp.to.x - @bp.from.x)		# ӂ̌X
			b = @bp.from.y - a * @bp.from.x													# ӂyؕ
			c = @top.y + @top.x / a																	# yؕ

			@hp.to.x = ( a * c - a * b ) / ( 1 + a * a )
			@hp.to.y = ( a * a * c + b ) / ( 1 + a * a )
		else
			@hp.to.x = @bp.to.x
			@hp.to.y = @top.y
		end

		@hp
	end

	# 
	def bottomPath
		@bp = @l1
		@top = @p3
		if @l2.length > @bp.length
			@bp = @l2
			@top = @p1
		end
		if @l3.length > @bp.length
			@bp = @l3
			@top = @p2
		end

		@bp
	end

	def paralleloArea( format )
		h = format.number!( heightPath.length / 1000 )
		b = format.number!( bottomPath.length / 1000 )
		p h, b, format, heightPath.length, bottomPath.length
		area = h * b
	end

	def area( format )
		h = format.number!( heightPath.length / 1000 )
		b = format.number!( bottomPath.length / 1000 )
		area = h * b * 0.5
	end
end


# CLASS: QƔԍNX
class Reference < String
  Katakana = "ACEGIJLNPRTVXZ\^`cegijklmnqtwz}~"
  Hiragana = "ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂"
  LastWord = 78

  Kansuji = "ZOlܘZ"

  def initialize( str )
    super( str )
    @root = str.gsub( /^(.*\-)(.*)$/, "\\1" )
    if $2 == nil
      @branch = @root
      @root = ""
    else
      @branch = $2
    end
    @default_branch = @branch.clone
  end

  def succ!
    str = @branch.clone
    pos = 0
    while str.length > 0
      c = str.gsub( /.*(.)/, "\\1" )
      if c =~ /\d/
        c = str.gsub( /.*?([0-9]+)$/, "\\1" )
      end
      for i in 1..c.length
        str.chop!
      end

      if c =~ /\d+/
        @branch[ str + c ] = str + c.succ
        overflow = false
      else
        new_c, overflow = next_char( c )
        @branch[ str.length, c.length ] = (new_c[ 0, c.length ])
      end
      if not overflow
        break
      end
    end

    case new_c
      when ""
        @branch[ str + new_c ] = ( str + "" )
      when "A"
        @branch[ str + new_c ] = ( str + "AA" )
      when "AA"
        @branch[ str + new_c[ 0, c.length ] ] = ( str + "AA" )
      when "aa"
        @branch[ str + new_c[ 0, c.length ] ] = ( str + "aa" )
      when "`"
        @branch[ str + new_c ] = ( str + "" )
      when "O"
        @branch[ str + new_c ] = ( str + "PO" )
      when "Z"
        @branch[ str + new_c ] = ( str + "Z" )
    end
  
    self.replace( @root + @branch )
  end

  def succ_root!
  	if @root != ""
	    str = @root.clone.gsub( /^(.*)\-$/, "\\1" )
	    pos = 0
	    while str.length > 0
	      c = str.gsub( /.*(.)/, "\\1" )
	      if c =~ /\d/
	        c = str.gsub( /.*?([0-9]+)$/, "\\1" )
	      end
	      for i in 1..c.length
	        str.chop!
	      end
	
	      if c =~ /\d+/
	        @root[ str + c ] = str + c.succ
	        overflow = false
	      else
	        new_c, overflow = next_char( c )
	        @root[ str.length, c.length ] = (new_c[ 0, c.length ])
	      end
	      if not overflow
	        break
	      end
	    end
	
	    case new_c
	      when ""
	        @root[ str + new_c ] = ( str + "" )
	      when "A"
	        @root[ str + new_c ] = ( str + "AA" )
	      when "AA"
	        @root[ str + new_c[ 0, c.length ] ] = ( str + "AA" )
	      when "aa"
	        @root[ str + new_c[ 0, c.length ] ] = ( str + "aa" )
	      when "`"
	        @root[ str + new_c ] = ( str + "" )
	      when "O"
	        @root[ str + new_c ] = ( str + "PO" )
	      when "Z"
	        @root[ str + new_c ] = ( str + "Z" )
	    end

			@branch = @default_branch.clone
	    self.replace( @root + @branch )
	  end
  end

  def next_char( c )
    case c
      when /[a-zA-Z]/
        new_c = c.succ
        if new_c.length > 1
          overflow = true
        else
          overflow = false
        end

        return new_c, overflow

      when /[A-]/
        isKatakana = Katakana.index( c )
        if isKatakana != nil
          if isKatakana < LastWord
            return Katakana[ isKatakana + 2, 2 ], false
          else
            return "A", true
          end
        end

      when /[-]/
        isHiragana = Hiragana.index( c )
        if isHiragana != nil
          if isHiragana < LastWord
            return Hiragana[ isHiragana + 2, 2 ], false
          else
            return "", true
          end
        end

      when ""
        return "", true

      when "y"
        return "`", true

      when "X"
        return "O",true

      when /[ZOlܘZ]/
        idx = Kansuji.index( c )
        if idx != nil
          if idx < 18
            return Kansuji[ idx + 2, 2 ], false
          else
            return "Z", true
          end
        end

      else
        return c.succ, false
    end
  end
end

# MIX-IN MODULE: 	TriangleArray
module TriangleArray
	include Comparable

	attr	:sortHorizontal,	true
	attr	:sortAscent,			true

	def center
		if @center == nil
			if length > 0
				@center = Point.new( 0, 0 )
				for item in self
					@center.x += item.center.x
					@center.y += item.center.y
					item.sortHorizontal = @sortHorizontal unless @sortHorizontal == nil
					item.sortAscent = @sortAscent unless @sortAscent == nil
				end
				@center.x /= self.length
				@center.y /= self.length
				@center.sortHorizontal = @sortHorizontal unless @sortHorizontal == nil
				@center.sortAscent = @sortAscent unless @sortAscent == nil
			end
		end
		
		@center
	end

	def <=>( other )
		self.center <=> other.center
	end
end

HeronsFormula.new path
